'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('babel-polyfill');

require('source-map-support/register');

var _soapAsPromised = require('soap-as-promised');

var _soapAsPromised2 = _interopRequireDefault(_soapAsPromised);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var PUBLISHER_SERVICE_WSDL_URL = 'http://api.affiliatewindow.com/v6/AffiliateService?wsdl';
var PRODUCT_SERVE_WSDL_URL = 'http://v3.core.com.productserve.com/ProductServeService.wsdl';

var AffiliateWindow = function () {
	function AffiliateWindow(_ref) {
		var publisherId = _ref.publisherId;
		var apiPassword = _ref.apiPassword;
		var productServeApiKey = _ref.productServeApiKey;

		_classCallCheck(this, AffiliateWindow);

		this.config = {
			publisherId: '',
			apiPassword: '',
			productServeApiKey: '34c105baeb240b5438defd7c45fef2d6'
		};

		this.config = Object.assign({}, this.config, {
			publisherId: publisherId,
			apiPassword: apiPassword,
			productServeApiKey: productServeApiKey
		});
	}

	_createClass(AffiliateWindow, [{
		key: 'connect',
		value: function connect(url) {
			var _this = this;

			return _soapAsPromised2.default.createClient(url).then(function (client) {
				var _config = _this.config;
				var iId = _config.publisherId;
				var sPassword = _config.apiPassword;
				var sApiKey = _config.productServeApiKey;

				client.addSoapHeader({
					UserAuthentication: {
						iId: iId,
						sPassword: sPassword,
						sApiKey: sApiKey,
						sType: 'affiliate'
					}
				});
				return client;
			});
		}
	}, {
		key: 'getMerchantsSimple',
		value: function getMerchantsSimple() {
			var _ref2 = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

			var _ref2$joined = _ref2.joined;
			var joined = _ref2$joined === undefined ? true : _ref2$joined;

			return this.connect(PUBLISHER_SERVICE_WSDL_URL).then(function (client) {
				return client.getMerchantList(joined ? { sRelationship: 'joined' } : {}).then(function (result) {
					var _result$getMerchantLi = result.getMerchantListReturn;
					var getMerchantListReturn = _result$getMerchantLi === undefined ? {} : _result$getMerchantLi;
					var _getMerchantListRetur = getMerchantListReturn.Merchant;
					var Merchant = _getMerchantListRetur === undefined ? [] : _getMerchantListRetur;

					return Merchant;
				});
			});
		}
	}, {
		key: 'getMerchants',
		value: function getMerchants() {
			var _this2 = this;

			var _ref3 = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

			var _ref3$joined = _ref3.joined;
			var joined = _ref3$joined === undefined ? true : _ref3$joined;

			return this.getMerchantsSimple({ joined: joined }).then(function (merchants) {
				var aMerchantIds = merchants.map(function (merchant) {
					return merchant.iId;
				});

				return _this2.connect(PUBLISHER_SERVICE_WSDL_URL).then(function (client) {
					var promises = aMerchantIds.map(function (id) {
						return client.getCommissionGroupList({ iMerchantId: id });
					});

					return Promise.all(promises).then(function (data) {
						return data.map(function (data) {
							return (data.getCommissionGroupListReturn || {}).CommissionGroup || [];
						});
					}).then(function (data) {
						return merchants.map(function (merchant, index) {
							var commissionGroups = data[index] ? Array.isArray(data[index]) ? data[index] : [data[index]] : [];
							commissionGroups = commissionGroups.map(function (group) {
								return Object.assign({}, group, {
									fPercentage: typeof group.fPercentage === 'string' ? +group.fPercentage : group.fPercentage,
									mAmount: group.mAmount ? Object.assign({}, group.mAmount, {
										dAmount: +group.mAmount.dAmount
									}) : null
								});
							});

							return Object.assign({}, merchant, {
								iId: +merchant.iId,
								aCommissionGroups: commissionGroups
							});
						});
					});
				});
			});
		}
	}, {
		key: 'getVouchers',
		value: function getVouchers() {
			var _this3 = this;

			return this.getMerchantsSimple({ joined: true }).then(function (merchants) {
				return _this3.connect(PRODUCT_SERVE_WSDL_URL).then(function (client) {
					var promises = merchants.map(function (merchant) {
						return merchant.iId;
					}).map(function (iMerchantId) {
						return client.getDiscountCodes({ iMerchantId: iMerchantId }).then(function (out) {
							return out && out.oDiscountCode || {};
						});
					});
					return Promise.all(promises).then(function (data) {
						var vouchers = data.reduce(function (previous, current) {
							return previous.concat(current);
						}, []).filter(function (voucher) {
							return voucher && voucher.sCode;
						});
						return vouchers;
					});
				});
			});
		}

		// TODO:

	}, {
		key: 'getLinks',
		value: function getLinks() {}
	}, {
		key: 'getTransactions',
		value: function getTransactions() {
			var _ref4 = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

			var _ref4$startDate = _ref4.startDate;
			var startDate = _ref4$startDate === undefined ? new Date(Date.now() - 30 * 1000 * 60 * 60 * 24).toISOString() : _ref4$startDate;
			var _ref4$endDate = _ref4.endDate;
			var endDate = _ref4$endDate === undefined ? new Date().toISOString() : _ref4$endDate;

			return this.connect(PUBLISHER_SERVICE_WSDL_URL).then(function (client) {
				return client.getTransactionList({
					dStartDate: startDate,
					dEndDate: endDate,
					sDateType: 'transaction',
					iLimit: 1000
				});
			}).then(function (result) {
				var _result$getTransactio = result.getTransactionListReturn;
				var getTransactionListReturn = _result$getTransactio === undefined ? {} : _result$getTransactio;

				var _ref5 = getTransactionListReturn || {};

				var _ref5$Transaction = _ref5.Transaction;
				var Transaction = _ref5$Transaction === undefined ? [] : _ref5$Transaction;

				return Array.isArray(Transaction) ? Transaction : [Transaction];
			});
		}
	}]);

	return AffiliateWindow;
}();

exports.default = AffiliateWindow;